Subject: RE: Timeout .....

From: [email-masked]
Date: Wed, 18 Aug 1999 11:33:49 +0530

Hi,
       My response to Randy's reply is inlined ...
----------
From: 	Randy Presuhn[SMTP:dorothy.bmc.com!rpresuhn]
Sent: 	Wednesday, August 18, 1999 5:01 AM
To: 	dorothy.bmc.com!agentx 
Subject: 	Re:  Timeout .....

> 1. My subagent has sent any pkt (open/index allot/Reg ) now problem is
> how long the sub-agent should wait for response from Master assuming
> there is no pkt loss as connection oriented but still Master may be
> overloaded and may take time in responding , this blocks my sub-agent
> con-current PDU processing if it waits for particular PDU's reponse sent
> by it to Master. If answer to this is you should have timer for getting
> response, then managing timer will be a overhead for every PDU sent.

[Randy]     Blocking while expecting a response is rarely a good idea.
Consider the case where the master agent dispatches a get
request after your subagent sends its request.  Will it
know what to do?
[Ravi] In the scenario of Master agent i have no problem as anyhow i have to
         start timer for it to wait for o.timeout [time event]sent by sub-agent
         during session  establishment. 
         So here Master agent is associated with time event for 
         every pkt it is dispatching to sub-agent. But here what i mean is 
         the sub-agent has sent say a open PDU now how long the sub-agent
         should wait [ for event say master_response to this open, it is not blocking 
         rather  waiting for just an event of many ] ?

> 2. The sub-agent has allocated index before registering and is mentioned
> in RFC if response for this Registration is "duplicateRegistration" then
> deallocate the index. In this scenario index-deallocation is clear , but
> say i have sent an unregister PDU for a fully qualified row in a table
> , now  shall the sub-agent should send corresponding index-deallocation
> PDU to free the index for that row or Master will take care of it. If
> Master then RFC also says that while allocating index master need not
> aware of type of index , so master is finding it difficult to free by
> seeing just the OID.
..

[Randy] Index allocation and registration should be completely decoupled
in a master agent.  Registration requests should have no effect
on index alllocation, and vice versa.
[Ravi] Index allocation is clear , let me put my question this way :
                If i have sent an unregister PDU for a full row in a sharable
         table , is there need for that index occupied by this row to 
         be de-allocated , if not the Master database will grow rapidly
         as it is maintaining what all the indexes it has allocated ? 
         If yes then who will de-allocate master itself or sub-agent has
         to send seperate index Deallocate-PDU.

Regards,
Ravi.

---

From: Mike Daniele <[email-masked]>
Date: Wed, 18 Aug 1999 09:05:24 -0400

>        My response to Randy's reply is inlined ...

I think the answer is to a large extent based on what API or framework your
AgentX code runs in.  As you say, it's implementation-specific.
[Ours is a library of services that keeps internal state based on the master agent's
responses, so in effect waits forever.]

> > PDU to free the index for that row or Master will take care of it.If

>          to send seperate index Deallocate-PDU.

the subagent should send a separate deallocate pdu.

mike